#pragma once


class CrSectionEx
{
public: 
	CrSectionEx()
	{
		InitializeCriticalSection(&m_criticalSection);
	}

	~CrSectionEx()
	{
		DeleteCriticalSection(&m_criticalSection);
	}

	void Enter()
	{
		EnterCriticalSection(&m_criticalSection);
	}

	void Leave()
	{
		LeaveCriticalSection(&m_criticalSection);
	}
private:
	CRITICAL_SECTION m_criticalSection;
};

class CAutoLock
{
public:
	CAutoLock(CrSectionEx* pCS);
	virtual ~CAutoLock(void);

private:
	CrSectionEx* m_pCS;
};
